# vd_ldapinfo.pm
#
# The exploit is a part of VulnDisco Pack - use only under the license agreement
# specified in LICENSE.txt in your VulnDisco distribution

use strict;

package Msf::Exploit::vd_ldapinfo;
use base "Msf::Exploit";
use Pex::Text;

my $advanced = { };

my $info = 
{
	"Name"      => "[0day] Query interesting info from LDAP server",
    	"Version"   => "\$Revision: 1.0 \$",
    	"Authors"   => ["Evgeny Legerov"],
    	"Arch"      => ["x86"],
    	"OS"        => ["linux"],
    	"Priv"      => 1,
    	"UserOpts"  =>
                {
                	"RHOST" => [1, "ADDR", "The target address"],
                    	"RPORT" => [1, "PORT", "The target port", 389]
                },

    	"Description" => Pex::Text::Freeform(q{
Little useful tool to query interesting info server version for example
from a remote LDAP server.
		}),

        "Keys"           => ["vd_ldapinfo"],
};

sub new	{
	my $class = shift;
	return $class->SUPER::new({"Info" => $info, "Advanced" => $advanced}, @_);
}

sub Exploit {
	my $self = shift;
        my $host = $self->GetVar("RHOST");
        my $port = $self->GetVar("RPORT");

 	my @attributes = ("vendorName",
		"vendorVersion", 
		"supportedLDAPVersion",
        	"supportedControl", 
		"supportedSASLMechanisms", 
		"supportedExtension",
                "supportedFeatures");

	my $results = {};

	for $a (@attributes) {
		$self->do_search($host, $port, $results, $a);
	}

        $self->PrintLine("Search results:");
       	for $a (@attributes) {
        	$self->PrintLine($a . ": [" . join(", ",@{$results->{$a}}) . "]");
	}
}

sub do_search {
	my ($self, $host, $port, $results, $attribute) = @_;

	my $attr = lc($attribute);

	$results->{$attribute} = [];
                
	my $s = "\x04" . $self->int2berlen(length($attr)) . $attr;
        $s = "\x30" . $self->int2berlen(length($s)) . $s;
        $s = "\x87" . $self->int2berlen(length("objectClass")) . "objectClass" .  $s;
        $s = "\x04\x00\x0a\x01\x00\x0a\x01\x00\x02\x01\x00\x02\x01\x00\x01\x01\x00" . $s;
        $s = "\x63" . $self->int2berlen(length($s)) . $s;
        $s = "\x02\x01\x01" . $s;
        $s = "\x30" . $self->int2berlen(length($s)) . $s;

 	my $sock = Msf::Socket::Tcp->new("PeerAddr" => $host, "PeerPort"  => $port);
        if ($sock->IsError) {
                $self->PrintLine("Error creating socket: " . $sock->GetError);
                return;
        }
	$sock->Send($s);
	$s = $sock->Recv(-1, 20);	
	$sock->Close();

        if (length($s) < 1 || index(lc($s),$attr) == -1) {
		return;
	}

        my $i = index(lc($s),$attr);
        $s = substr($s,$i + length($attr));
                
	if (length($s) < 1 || ord(substr($s,0,1)) != 0x31) {
		return;
	}

        $s = substr($s,1);
        my @l = $self->ber_length($s);
        if ($l[0] < 0 || length($s) < $l[0] + $l[1]) {
		return;
	}
  
	$s = substr($s, $l[1], $l[0]);
       	while (1) {
	     	if (length($s) <1 || ord(substr($s,0)) != 0x04) {
			last;
		}

                $s = substr($s, 1);
                @l = $self->ber_length($s);
                if (length($s) < $l[0] + $l[1]) {
			last;
		}

                push @{$results->{$attribute}}, substr($s, $l[1], $l[0]);
                $s = substr($s, $l[1] + $l[0]);
	}
}

# helper routines
sub int2berlen {
	my ($self, $i) = @_;
        my $e = $self->int2ber($i, 0);
        if ($i <= 127) {
                return $e;
        } else {
                my $l = length($e);
                return chr(0x80|$l) . $e;
	}
}

sub int2ber {
	my ($self, $i, $signed) = @_;
        my $encoded = "";
        while ( ($signed && ($i>127 || $i<-128)) || (!$signed && ($i>255)) ) {
                $encoded = chr($i%256) . $encoded;
                $i = $i>>8;
	}
        $encoded = chr($i%256) . $encoded;
        return $encoded;
}
sub ber2int {
	my ($self, $e, $signed) = @_;
    	my $v = 0 + ord(substr($e,0,1));
    	if ($v&0x80 && $signed) {
        	$v = $v - 256;
	}
    	for (my $i=1; $i < length($e); $i++) {
        	$v=($v<<8) | ord(substr($e,$i,1));
	}
    	return $v;
}

sub ber_length {
	my ($self, $m, $offset) = @_;
    	my $l = $self->ber2int(substr($m,$offset,1), 1);
    	my $ll = 1;
    	if ($l&0x80) {
        	$ll = 1+($l&0x7F);
        	$l = $self->ber2int(substr($m,$offset + 1, $ll - 1), 0);
	}
    	return ($l,$ll);
}

__END__
