#!/bin/sh
# VULNDISCO for Metasploit install script
# version 1.0

READ=read
OS=`/bin/uname`

function or_die()
{
  if [ -z "$1" ]
  then
    echo "Operation failed. Exiting."
    exec /bin/false
  fi
    echo "Failure: $1"
    exec /bin/false
}

if [ -z "$OS" ]
then
  echo "Unable to determine operating system type"
else
  if [ "${OS:0:6}" = "CYGWIN" ]
  then
   echo "Detected Cygwin. Will perform additional checks."
   IS_CYGWIN=YES
   READ="read -r"
  fi
fi

more LICENSE.txt
echo -n "Do you agree to the terms (yes/no)? [no]"
$READ input
if [ -z "$input" ]
then
  input="no"
fi

if [ "$input" = "no" -o "$input" = "No" ]
then
  echo "Did not accept the LICENSE, exiting setup"
  exit
fi
if [ "$input" != "yes" -a "$input" != "Yes" ]
then
  echo "Please answer Yes or No"
  exit
fi

echo 
echo "Enter the absolute path of Metasploit installation directory [/opt/metasploit]"
echo -n ":"
$READ META_PATH
if [ -z "$META_PATH" ]
then
  META_PATH="/opt/metasploit"
fi
if [ -d "$META_PATH" ]
then
  echo "Installing the pack to $META_PATH"

  if [ ! -d "$META_PATH/VULNDISCO" ]
  then
        mkdir "$META_PATH/VULNDISCO"
  fi

  echo "1. Creating vd_libs/vulndisco.pm..."
  echo "my \$INSTALL_PATH=\"$META_PATH\";" > vd_libs/vulndisco.pm
  echo "my \$VERSION=\"1.0\";" >> vd_libs/vulndisco.pm

  echo "2. Copying text files..."
  cp -fR *.txt "$META_PATH/VULNDISCO" || or_die "bad path?"

  echo "3. Copying documentation..."	
  cp -fR docs "$META_PATH/VULNDISCO" || or_die "bad path"

  echo "4. Copying VulnDisco libraries..."
  cp -fR vd_libs "$META_PATH/VULNDISCO" || or_die "bad path?"

  echo "5. Copying VulnDisco exploit modules..."
  cp -fR exploits/vd_* "$META_PATH/exploits" || or_die "bad path?"
else
  echo "The directory $META_PATH does not exist!"
  exit
fi

echo
echo "Congratulations, you successfully installed VulnDisco Pack for Metasploit!"
echo "If you have any questions or problems - please contact us via email info@gleg.net"
echo
